part of example.basic_auth.server;

/// Collection of routes students can also access
@Api(path: '/book')
@WrapOne(#authorizer)
class StudentRoutes {
  @Get(path: '/all')
  Response<String> getAllBooks(Context ctx) {
    List<Map> ret = _books.values.map((Book book) => book.toMap()).toList();
    return Response.json(ret);
  }

  @Get(path: '/:id')
  String getBook(Context ctx) {
    String id = ctx.pathParams.get('id');
    Book book = _books[id];
    return book.toJson();
  }

  Authorizer authorizer(Context ctx) => new Authorizer(kModelManager);
}
