library jaguar_auth.authenticator;

import 'dart:async';

import 'package:jaguar_common/jaguar_common.dart';

export 'package:jaguar_common/jaguar_common.dart';

/// Specifies an interface that authenticators and authorizers use
/// to manage [AuthorizationUser]
abstract class AuthModelManager {
  /// Returns user ([AuthorizationUser]) by given [authenticationId]
  Future<AuthorizationUser> fetchModelByAuthenticationId(
      String authenticationId);

  /// Returns user ([AuthorizationUser]) by given [authorizationId]
  Future<AuthorizationUser> fetchModelByAuthorizationId(String authorizationId);

  /// Checks password [keyword] for given userId [authId] and
  /// returns the user ([AuthorizationUser]) if passwords match. Returns [null]
  /// if the password doesn't match or user with given authId is not found.
  Future<AuthorizationUser> authenticate(String authId, String keyword);
}
